<cfcomponent>
	<cfset variables.config = createobject("component", "config").init() />
	
	<cffunction name="init" returntype="RemoteObject" output="false" access="public" hint="I perform initialization functions for this component">
		<cfreturn this />
	</cffunction>
	
	<cffunction name="loadTypedStruct" output="false" access="remote" returntype="any" hint="I return an array of typed struct data set to be piped through LiveCycle or Flash Remoting">
		<cfset var data = loadQuery() />
		<cfset var result = arrayNew(1) />
		<cfset var VO = structNew() />
		<cfoutput query="data">
			<cfset VO['__type__'] = "CFAIR.vo.DatasetVO" />
			<cfset VO['category'] = Category />
			<cfset VO['amount'] = Amount />
			<cfset arrayAppend( result, VO ) />
		</cfoutput>
		
		<cfreturn result />		 		
	</cffunction>
	
	<cffunction name="loadVO" output="false" access="remote" returntype="DataRow[]" hint="I return an array of Value Objects">
		<cfset var data = loadQuery() />
		<cfset var result = arrayNew(1) />
		<cfset var VO = "" />
		<cfoutput query="data">
			<cfset VO = createobject("component", "DataRow") />
			<cfset VO['category'] = Category />
			<cfset VO['amount'] = Amount />
			<cfset arrayAppend( result, VO ) />
		</cfoutput>
		
		<cfreturn result />		 		
	</cffunction>

	<cffunction name="loadQuery" output="false" access="private" returntype="query" hint="I return a query">
		<cfset var topCommentedEntries = "" />
			<cfquery name="topCommentedEntries" datasource="#variables.config.getDatasource()#">
				select tblblogentries.title as Category, count(tblblogcomments.id) as Amount
				from			tblblogentries, tblblogcomments
				where			tblblogcomments.entryidfk = tblblogentries.id
				group by		tblblogentries.id, Category
				order by	Amount desc
				limit 10
			</cfquery>
		<cfreturn topCommentedEntries />
	</cffunction>
	

	
</cfcomponent>