<cfcomponent>
	<cfset variables.config = createobject("component", "config").init() />
	
	<cffunction name="init" returntype="WebService" output="false" access="public" hint="I perform initialization functions for this component">
		<cfreturn this />
	</cffunction>
	
	<cffunction name="loadVO" output="false" access="remote" returntype="DataRow[]" hint="I return an array of Value Objects">
		<cfset var data = loadQuery() />
		<cfset var result = arrayNew(1) />
		<cfset var VO = "" />
		<cfoutput query="data">
			<cfset VO = createobject("component", "DataRow") />
			<cfset VO['category'] = Category />
			<cfset VO['amount'] = Amount />
			<cfset arrayAppend( result, VO ) />
		</cfoutput>
		
		<cfreturn result />		 		
	</cffunction>

	<cffunction name="loadQuery" output="false" access="private" returntype="query" hint="I return a query">
		<cfset var topCommentedEntries = "" />
			<cfquery name="topCommenters" datasource="#variables.config.getDatasource()#" maxrows="10">
				select 			tblblogcategories.categoryid, tblblogcategories.categoryname as Category, count(tblblogcomments.id) as Amount
				from			tblblogcategories, tblblogcomments, tblblogentriescategories
				where			tblblogcomments.entryidfk = tblblogentriescategories.entryidfk
				and				tblblogentriescategories.categoryidfk = tblblogcategories.categoryid
				group by		tblblogcategories.categoryid, Category 
				order by	Amount desc
			</cfquery>
		<cfreturn topCommenters />
	</cffunction>
	

	
</cfcomponent>